#include <stdio.h>
#include <conio.h>
#include "exam01.h"

#define SIZE 4
#define COLS (SIZE+1)
#define ROWS SIZE

float matriz[ROWS][COLS]={{4,5,6,7,8},{1,4,5,6,3},{3,4,56,34,3},{9,0,7,5,4}}

int Intercambia(int,int);
void Multiplica(int, float);
void PoneCeros(int,float, int);



 /***********************************************************************
 *	Antes de compilar en el men'u Project/Open project, abre el         *
 *	proyecto llamado exam01.prj                                         *
 *                                                                      *
 *	Antes de correr el programa en el men'u Run/Argumets escribe        *
 *				mtx.001 out.001                                         *
 *  o c'orrelo desde DOS:                                               *
 *              c:\> mainsmpl mtx.001 out.001                           *
 ***********************************************************************/

 /***********************************************************************
 *	Main                                                                *
 *                                                                      *
 *	Sintaxis:                                                           *
 *		mainsmpl archivo_entrada archivo_salida                         *
 *                                                                      *
 *	archivo_entrada debe contener una matriz en el formato especificado *
 *	en la documetaci'on de InitMatrix.                                  *
 *                                                                      *
 *	Observaciones:                                                      *
 *  archivo_salida ser'a sobreescrito cada vez que el programa se corra	*
 ***********************************************************************/

int main(int argc, char *argv[] )
{
	 /*******************************************************************
	 *  Aqu'i debe de ir tu parte del c'odigo que aplica el m'etodo de  *
	 *	Gauss-Jordan a la matriz                                        *
	 *******************************************************************/
	 int  a=0;
	 int i,col,bandera=1;
	 float num, vfun, factor;
	 clrscr();

	 InitMatrix( matriz[0], ROWS, COLS, argv[1] );



	 for(col=0; col<4; col++,bandera=1)    /*comienza el ciclo de columnas*/
	{
	  a=0;
	  i=0;
		 while( (bandera==1) && (col+a<4) )
		  {                                  /*busca enrada distinta de cero*/
		    if (matriz[col+a][col]!=0)
		       {
			Intercambia(col,col+a);    /*manda llamar a intercambia*/
			bandera=0;
			a++;
		       }
		    else
			a++;


		   }

	      if(col+a>=4)
		  break;
	      num=matriz[col][col];
	      vfun=1/num;
	      Multiplica(col,vfun);     /*Manda llamar a Multiplica*/


	      for(i=0;i<4; i++)     /*busca renglones a los que se deba sumar algo*/
		  {
		    if((i!=col) && (matriz[i][col]!=0))

		      {   factor=matriz[i][col];
			  PoneCeros(i,factor, col);      /*invoca a poneCeros*/
		       }


		  }

	   }



	if( argc < 3 )
	{
		printf("\n La sintaxis para este programa es: \n\n");
		printf("\t mainsmpl archivo_entrada archivo_salida \n\n");
		printf("\t archivo_entrada debe contener una matriz en el formato \n");
		printf("\t especificado en la documetaci'on de InitMatrix. \n\n");
	}



	PrintMatrix( "out", matriz[0], ROWS, COLS);
	PrintMatrix( argv[2] , matriz[0], ROWS, COLS);




   return 0;

}





int  Intercambia (int col, int col_a)  /*intercambia*/
{
  float arreglo[5]={0,0,0,0,0};      /*renglon recipiente*/
  int j=0;

  for( j=0; j<5; j++)
	  {
	   arreglo[j]=matriz[col_a][j];    /*hace los intercambios entrada por entrada*/
	   matriz[col_a][j]=matriz[col][j];
	   matriz[col][j]=arreglo[j];

	  }

 return 1;
}


void Multiplica(int i, float num)    /*multiplica*/
{
 int j;
 for(j=0; j<5; j++)
	 matriz[i][j]=(matriz[i][j]*num);


 }



 void PoneCeros(int i, float factor, int col)      /*PoneCeros*/
 {
   int j;

   for( j =0; j < 5 ; j++ )
	  matriz[i][j] = matriz[i][j] - (factor * matriz[col][j]);

  }

