#include <stdio.h>
#include <alloc.h>

struct Nodo
{
  int num;
  struct Nodo *menor;
  struct Nodo *mayor;

};


struct Nodo *InsertarNumero(struct Nodo *raiz,int num);
void Desplegar(struct Nodo *raiz);
void ImprimirNodo(struct Nodo *nodo);

main()
{
  struct Nodo *raiz;
  int num;

  raiz=NULL;
  printf("\nTeclea un nmero:");
  scanf("%d",&num);
  
  while(num != -1)
  {
	 raiz=InsertarNumero(raiz,num);

	 printf("\nTeclea un nmero:");
	 scanf("%d",&num);
  }

  Desplegar(raiz);

  getch();

  return;

}

struct Nodo *InsertarNumero(struct Nodo *raiz,int num)
{
   if(raiz == NULL)
   {
	   raiz=(struct Nodo *)malloc(sizeof(struct Nodo));
	   if(raiz==NULL) return NULL;
	   raiz->num=num;
	   raiz->menor=NULL;
	   raiz->mayor=NULL;
	   return raiz;
   }

   if(num < raiz->num)
	   raiz->menor=InsertarNumero(raiz->menor,num);
   else
	   raiz->mayor=InsertarNumero(raiz->mayor,num);


   return raiz;

}


void Desplegar(struct Nodo *raiz)
{
   if(raiz == NULL)  return;

   Desplegar(raiz->menor);
   ImprimirNodo(raiz);
   Desplegar(raiz->mayor);

}


void ImprimirNodo(struct Nodo *nodo)
{
	printf("\nNmero :%d",nodo->num);

	if(nodo->menor == NULL)
		printf("\t-");
	else
		printf("\t%d",nodo->menor->num);

	if(nodo->mayor == NULL)
		printf("\t-");
	else
		printf("\t%d",nodo->mayor->num);

}