#define SIZE 4
#define COLS (SIZE+1)
#define ROWS SIZE

#include "exam01.h"

 /***********************************************************************
 *	Antes de compilar en el men'u Project/Open project, abre el         *
 *	proyecto llamado exam01.prj                                         *
 *                                                                      *
 *	Antes de correr el programa en el men'u Run/Argumets escribe        *
 *				mtx.001 out.001                                         *
 *  o c'orrelo desde DOS:                                               *
 *              c:\> mainsmpl mtx.001 out.001                           *
 ***********************************************************************/

 /***********************************************************************
 *	Main                                                                *
 *                                                                      *
 *	Sintaxis:                                                           *
 *		mainsmpl archivo_entrada archivo_salida                         *
 *                                                                      *
 *	archivo_entrada debe contener una matriz en el formato especificado *
 *	en la documetaci'on de InitMatrix.                                  *
 *                                                                      *
 *	Observaciones:                                                      *
 *  archivo_salida ser'a sobreescrito cada vez que el programa se corra	*
 ***********************************************************************/

int main(int argc, char *argv[] )
{
	float epsilon = 10E-5;
	float temp[5];
	int i, j, k;
	float matrix[ROWS][COLS];

	if( argc < 3 )
	{
		printf("\n La sintaxis para este programa es: \n\n");
		printf("\t mainsmpl archivo_entrada archivo_salida \n\n");
		printf("\t archivo_entrada debe contener una matriz en el formato \n");
		printf("\t especificado en la documetaci'on de InitMatrix. \n\n");
	}

	InitMatrix( matrix[0], ROWS, COLS, argv[1] );

	 /*******************************************************************
	 *  Aqu'i debe de ir tu parte del c'odigo que aplica el m'etodo de  *
	 *	Gauss-Jordan a la matriz                                        *
	 *******************************************************************/


	for (i = 0; i < 4; i++)
	  if (-epsilon < matrix[i][i] && matrix[i][i] < epsilon)
		{
		  for (j = i+1; j < 4; j++)
			if (matrix[j][i] > epsilon || matrix[j][i] < -epsilon)
			  break;
		  if (j < 4)
			{
			  for (k = 0; k < 5; k++)
				temp[k] = matrix[i][k];
			  for (k = 0; k < 5; k++)
				matrix[i][k] = matrix[j][k];
			  for (k = 0; k < 5; k++)
				matrix[j][k] = temp[k];
			}
		  else
			{
			  printf("ERROR - elemento de la diagonal cero\n");
			  PrintMatrix( "out", matrix[0], ROWS, COLS);
			  return 1;
			}
		}
	for(j = i+1; j < 4; j++)
		if(matrix[j][i] >epsilon || matrix[j][i] < -epsilon)
		break;
		if(j < 4)
		{
			for(k = 0; k < 5; k++)
			matrix[i][k] = matrix[j][k];
			for(k = 0; k < 5; k++)
			matrix[j][k] = temp[k];
		}
	for (i = 0; i < 3; i++)
	  {
		for (j = 5; j; j--)
		  matrix[i][j-1] = matrix[i][j-1] / matrix[i][i];
		for (j = i+1; j < 4; j++)
		  if (-epsilon > matrix[j][i] || matrix[j][i] > epsilon)
			{
			  for (k = 0; k < 5; k++)
				temp[k] = matrix[i][k] * matrix[j][k];
			  for (k = 0; k < 5; k++)
				matrix[j][k] = matrix[j][k] - temp[k];
			}
	  }

	matrix[i][i+1] = matrix[i][i+1] / matrix[i][i];
	matrix[i][i] = matrix[i][i] / matrix[i][i];

	PrintMatrix( "out", matrix[0], ROWS, COLS);
	PrintMatrix( argv[2] , matrix[0], ROWS, COLS);
	return 0;
}
